''
'' *** Hangman BASIC ***
''

CON
  
  x_tiles = 16
  y_tiles = 12

  paramcount   = 14       
  bitmap_base  = $2000
  display_base = $5000
  
  x_cor = -128 
  y_cor = -100  

    
VAR

  long  tv_status     '0/1/2 = off/visible/invisible           read-only
  long  tv_enable     '0/? = off/on                            write-only
  long  tv_pins       '%ppmmm = pins                           write-only
  long  tv_mode       '%ccinp = chroma,interlace,ntsc/pal,swap write-only
  long  tv_screen     'pointer to screen (words)               write-only
  long  tv_colors     'pointer to colors (longs)               write-only               
  long  tv_hc         'horizontal cells                        write-only
  long  tv_vc         'vertical cells                          write-only
  long  tv_hx         'horizontal cell expansion               write-only
  long  tv_vx         'vertical cell expansion                 write-only
  long  tv_ho         'horizontal offset                       write-only
  long  tv_vo         'vertical offset                         write-only
  long  tv_broadcast  'broadcast frequency (Hz)                write-only
  long  tv_auralcog   'aural fm cog                            write-only
  word  screen[x_tiles * y_tiles]
  long  colors[64]                                                                                        
  
  
OBJ

  tv    : "tv"
  gr    : "ha_graphics"  ' x: -127 -> 128  y: -96 -> 95  
  kb    : "keyboard"


PUB Start | i, dx, dy

  ' start tv
  longmove(@tv_status, @tvparams, paramcount)
  tv_screen := @screen
  tv_colors := @colors
  tv.start(@tv_status)

  ' init colors
  repeat i from 0 to 63
    colors[i] := $00001010 * (i+4) & $F + $2B060C02

  ' init tile screen
  repeat dx from 0 to tv_hc - 1
    repeat dy from 0 to tv_vc - 1
      screen[dy * tv_hc + dx] := display_base >> 6 + dy + dx * tv_vc + ((dy & $3F) << 10)

  ' start and setup graphics
  gr.start
  gr.setup(16, 12, 128, 96, bitmap_base)
  gr.color(2)

  ' start keyboard
  kb.start(26, 27)


PRI PresentScr

  gr.copy(display_base)


PUB BEEP(d,p)

  ' under construction
  ' sound

  
PUB CIRCLE(x,y,r) | i

  ' incomplete, works only for the head
  
  repeat i from 1 to 160
    gr.arc(x+x_cor, y+y_cor, r, r, i*50, 0, 1, 0)                                           
  PresentScr

  
PUB CLS   ' clear screen

  gr.clear              
  PresentScr
  

PUB DRAW(x1,y1,x2,y2,r) | i

  ' incomplete, works only for the mouth

  x1 := x1 + x_cor
  y1 := y1 + y_cor
  x2 := x1 + x2
  y2 := y1 + y2

  r  := (x2-x1) / 2 
  x1 := x1 + ((x2-x1) / 2)
  y1 := y1 - ((y2-y1) / 2) 
  repeat i from 1 to 40
    gr.arc(x1, y1, r, r-1, i*100, 0, 1, 0)
  PresentScr

  
PUB INPUT(string_ptr) | i, temp, tmp    
  
  ' input text  
  PRINT_AT(12,0,string_ptr)
  
  ' --- type --- 
  temp := string("         ")                                 ' <-----------------???      
  i := 0                                                    
  repeat                         
    BYTE[temp][i] := kb.newkey            
    if BYTE[temp][i] == $0C8                            ' $0C8 = BACKSPACE
      if i > 0        
        i--  
      BYTE[temp][i] := 0        
      PRINT_AT(12,strsize(string_ptr)+strsize(temp),string(" "))
    elseif BYTE[temp][i] == $00D                        ' $00D = RETURN  
      BYTE[temp][i] := 0
      quit
    elseif i < 8                                        ' other keys. max 8 character
      BYTE[temp][i+1] := 0                              
      tmp := BYTE[temp][i]                                    ' <-----------------!!!    
      PRINT_AT(12,strsize(string_ptr)-1+strsize(temp),@tmp)   ' <-----------------!!!
      i++
    PresentScr   
  ' --- type end ---  
        
  ' rub out input text & typed characters
  repeat i from 0 to strsize(string_ptr) + strsize(temp)-1
    PRINT_AT(12,i,string(" ")) 
            
  ' return typed characters       
  result := temp

  
PUB LINE(x,y)

  gr.line(x+x_cor,y+y_cor)   
  PresentScr
  
  
PUB OVER(n)

  if n == 0
    gr.color(2)
  else
    gr.color(0)


PUB PAUSE(n) ' n = 1/50 second

  waitcnt(clkfreq / 50 * n + cnt)

      
PUB PLOT(x,y)
                
  gr.plot(x+x_cor,y+y_cor)
  PresentScr
  

PUB PRINT_AT(y,x,string_ptr) | i

  ' x: 0=screen top,  12=screen bottom
  ' y: 0=screen left, 41=screen right
  
  gr.color(0)  
  repeat i from 0 to strsize(string_ptr)-1            
    gr.quad((x+i)*6-127,82-y*14, (x+i)*6-127,95-y*14, (x+i)*6-123,95-y*14, (x+i)*6-123,82-y*14)    'x1, y1, x2, y2, x3, y3, x4, y4    
  gr.color(2)
  gr.text(x*6-127,82-y*14,string_ptr)
  PresentScr


PUB RND(n)

  ' under construction

  result := 0
  
  
DAT

tvparams                long    0               'status
                        long    1               'enable
                        long    %001_0101       'pins
                        long    %0000           'mode
                        long    0               'screen
                        long    0               'colors
                        long    x_tiles         'hc
                        long    y_tiles         'vc
                        long    10              'hx
                        long    1               'vx
                        long    0               'ho
                        long    0               'vo
                        long    0               'broadcast
                        long    0               'auralcog
                        
                        