''
'' *** H A N G M A N ***
''
''   v0.12 - 2007,sep,10                
''

CON                                                          
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000  
  _stack   = ($3000 + $3000 + 250) >> 2   'accomodate display memory and stack
    
VAR
  long  gS, vS, wS              '                       '<------------------???           
  byte  free                    ' boolean
  byte  guess_ok                ' boolean  
  
OBJ
  ba : "ha_basic"
  
PUB Play_Hangman | n, m, b, c, d, i, temp
 
  ' initialize graphics, start tv & keyboard
  ba.Start
  
  ' ??? 
  vS := string("         ")                              '<------------------???
  m := 0                                                                   

  '--- Main Loop ---
  repeat        
  
    ' clear screen
    ba.CLS
    
    ' draw man 
    DrawMan(150)
                    
    ' draw floor
    Drawing(-50,20,20)
        
    ' get a secret word    
    wS := @@secretword[m]    
    b  := strsize(wS)
    m := m + 2
    if m > 14
      m := 0
            
    ' reset   
    c := 0
    d := 1
    free := false
    repeat i from 0 to 7     
      BYTE[vS][i] := " "      

    ' placeholders for secret word letters                              
    repeat n from 0 to b-1           
      ba.PRINT_AT(10,n,string("-"))
    
    '--- Lets Play Loop ---       
    repeat                                 

      ' keyboard input
      repeat                                                                              
        gS := ba.INPUT(string("Guess a letter: "))           
        if strsize(gS) > 1                              ' Only one character is allowed                             
          BYTE[gS] := 0                                 ' 
      while BYTE[gS] == 0                               '                           
                         
      ' print typed character from the input                            
      ba.PRINT_AT(0,c,gS)                                     
      c++
                 
      ' check character from the input
      guess_ok := false       
      repeat n from 0 to b-1                                   
        if BYTE[wS][n] == BYTE[gS]      
          BYTE[vS][n] := BYTE[gS]
          guess_ok := true
      if not guess_ok  
        if d < 8   
          DrawGallow(-50,d)
        d++
         
      ' print all right guessed letters               
      ba.PRINT_AT(9,0,vS)
                       
      ' if word guessed, then give the man a ticket to freedom
      temp := 0                             
      repeat i from 0 to strsize(wS)-1
        if BYTE[vS][i] == BYTE[wS][i]  
          temp++
      if temp == i
        free := true
        quit                                            ' quit loop
                                                                
      ' if there are eight wrong guess, then hang the man
      if d > 8                                                             
        quit                                            ' quit loop                 
    '--- Lets Play Loop End ---

    
    '--- Hanged or a Free Man ---   
    if free
      FreeMan
    else                                                 
      HangMan
      ba.PRINT_AT(9,0,wS)   


    '--- Game Over ---
    ba.PAUSE(150)    
    ba.INPUT(string("Play again? "))        
   

PUB DrawGallow(xh,n)

  Drawing(xh,20+n,20+n)
  
  
PUB HangMan

  ' mouth (frown)            
  ba.DRAW(187, 126, 6, 0, 8)   
  
  ba.PAUSE(100)
                   
  '--- rub out ---
  ba.OVER(1)                 
  ' mouth (frown)         
  ba.DRAW(150+37, 126, 6, 0, 8)
  ' floor
  Drawing(150,10,10)

  '--- draw ---
  ba.OVER(0)
  ' trappdoor
  Drawing(150,11,11)
  
  '--- rub out ---
  ba.OVER(1)
  ' limbs
  Drawing(150,6,9)
   
  '--- draw ---
  ba.OVER(0)
  ' mouth  
  ba.CIRCLE(150+40,127,2)
  ' eyes & limbs 
  Drawing(150,12,19)   
     

PUB FreeMan                                           

  ' rub out
  ba.OVER(1)
  DrawMan(150)
  ' draw
  ba.OVER(0)
  DrawMan(56) 


PUB DrawMan(xh) ' draw man at xh
  
  ' head
  ba.CIRCLE(xh+40,132,8)  
  ' eyes, nose, mouth, body & limbs 
  Drawing(xh,0,9)  
  

PUB Drawing(xh,start,end) | i, j

  repeat i from start to end
    j := i * 4                                                              
    ba.PLOT(BYTE[@hangmandata][j  ]+xh, BYTE[@hangmandata][j+1])
    ba.LINE(BYTE[@hangmandata][j+2]+xh, BYTE[@hangmandata][j+3])  

     
DAT 
                        
hangmandata

          ' draw & rub out         
          byte   36, 134,  36, 134,  44, 134,  44, 134  ' eyes                       
          byte   40, 131,  40, 132                      ' nose
          byte   38, 128,  42, 128                      ' mouth

          ' draw & rub out 
          byte   40, 123,  40, 103,  40, 101,  40,  82  ' body                        
          byte   55, 117,  40, 102,  40, 102,  25, 117  ' arms                  
          byte   55,  66,  40,  81,  40,  81,  25,  66  ' legs                        

          ' hanged - rub out
          byte   55,  65,   7,  65                      ' piece of floor
                        
          ' hanged - draw                        
          byte    7,  65,   7,  17                      ' trappdoor                        
          byte   35, 133,  37, 135,  35, 135,  37, 133  ' left eye
          byte   43, 133,  45, 135,  43, 135,  45, 133  ' right eye                                                
          byte   36,  81,  40, 102,  40, 102,  44,  81  ' arms                                                                    
          byte   36,  60,  40,  81,  40,  81,  44,  60  ' legs
                        
          ' gallow - draw      
          byte  120,  65, 255,  65, 184,  65, 184, 156  ' floor, gallow
          byte  168,  65, 184,  81, 184,  81, 200,  65  ' gallow
          byte  184, 156, 252, 156, 184, 140, 200, 156  ' gallow
          byte  204, 156, 184, 136, 240, 156, 240, 140  ' gallow, rope

                        
secretword
          word       @wStr0, @wstr1, @wStr2, @wStr3
          word       @wStr4, @wStr5, @wStr6, @wStr7                        
          wStr0      byte  "lion"    , 0
          wStr1      byte  "cat"     , 0
          wStr2      byte  "fish"    , 0  
          wStr3      byte  "tiger"   , 0
          wStr4      byte  "shark"   , 0
          wStr5      byte  "dog"     , 0
          wStr6      byte  "bird"    , 0
          wStr7      byte  "eagle"   , 0 

                        